[s2,cc2,v2] = polynomial([x;xp],s2_deg);  

for j=1:nx   
    [mu3(j),mu3c{j},mu3v{j}] = polynomial([x;xp],mu3_deg);
end

if (number == 1)
    [cV,vV] = coefficients(Vx,x);
    cVp = flip(cV);
    Vdegl = degree(Vx); %Vdeg = 2 on first iteration
    Vpm = monolist(xp,Vdegl,2);
    Vxp = cVp'*Vpm;
else 
    Vxp = Vxc'*Vpv;
end


F2 = -Vxp + gamma*Vx - mu3*(xp-A*x-B*u)- s2*px;

params = [];
for j = 1:nx
    params = [params;mu3c{j}];
end

params = [params;cc2];

Model = [sos(F2),sos(s2)];
%ops = sdpsettings('sos.model',1,'sos.postprocess',1,'sos.numblkdg',1e-10,'solver','sdpt3','sdpt3.gaptol',1e-9,'sdpt3.inftol',1e-9,'sdpt3.steptol',1e-9,'sdpt3.maxit',100);
ops = sdpsettings('solver','mosek','mosek.MSK_DPAR_INTPNT_CO_TOL_DFEAS',optacc,'mosek.MSK_DPAR_INTPNT_CO_TOL_PFEAS',optacc,'mosek.MSK_DPAR_INTPNT_CO_TOL_REL_GAP',optacc,'sos.numblkdg',1e-12,'sos.model',1,'sos.postprocess',1);
%ops = sdpsettings(ops,'mosek.MSK_IPAR_PRESOLVE_USE','MSK_PRESOLVE_MODE_OFF','mosek.MSK_IPAR_INTPNT_SCALING','MSK_SCALING_NONE');
[sol,v,Qs,res] =solvesos(Model,[],ops,params);
sprob_s2 = sol.problem
if (max(res) > 1e-6)
    sprob_s2 = -10
end

if (sprob_s2 ~= 0)
    %ops = sdpsettings('sos.model',2,'sos.postprocess',0,'sos.numblkdg',0,'solver','sdpt3','sdpt3.gaptol',1e-10,'sdpt3.inftol',1e-10,'sdpt3.steptol',1e-10,'sdpt3.maxit',100);
    ops = sdpsettings('solver','mosek','mosek.MSK_DPAR_INTPNT_CO_TOL_DFEAS',optacc,'mosek.MSK_DPAR_INTPNT_CO_TOL_PFEAS',optacc,'mosek.MSK_DPAR_INTPNT_CO_TOL_REL_GAP',optacc,'sos.numblkdg',0,'sos.model',2,'sos.postprocess',0);
    %ops = sdpsettings(ops,'mosek.MSK_IPAR_PRESOLVE_USE','MSK_PRESOLVE_MODE_OFF','mosek.MSK_IPAR_INTPNT_SCALING','MSK_SCALING_NONE');
    [sol,v,Qs,res] =solvesos(Model,[],ops,params);
    sprob_s2 = sol.problem
    maxres = max(res)
end

if (max(res) > 1e-6)
    sprob_s2 = -10
end

if (sprob_s2 == 0)
    Cc2 = value(cc2);
    S2 = Cc2'*v2;

    for j=1:nx   
        Mu3c{j} = value(mu3c{j});
        Mu3(j) = Mu3c{j}'*mu3v{j};
    end
end