[s6,cc6,v6] = polynomial(x,s6_deg);
F6 = (1-Vx)-s6*(1-Vxprev);
params = cc6;

Model = [sos(F6),sos(s6)];

ops = sdpsettings('solver','mosek','mosek.MSK_DPAR_INTPNT_CO_TOL_DFEAS',optacc,'mosek.MSK_DPAR_INTPNT_CO_TOL_PFEAS',optacc,'mosek.MSK_DPAR_INTPNT_CO_TOL_REL_GAP',optacc,'sos.numblkdg',1e-10,'sos.model',1,'sos.postprocess',1);
%ops = sdpsettings(ops,'mosek.MSK_IPAR_PRESOLVE_USE','MSK_PRESOLVE_MODE_OFF','mosek.MSK_IPAR_INTPNT_SCALING','MSK_SCALING_NONE');
[sol,v,Qs,res] =solvesos(Model,[],ops,params);
sprob_s6 = sol.problem
if (max(res) > 1e-6)
    sprob_s6 = -10
end

Cc6 = value(cc6);
S6 = Cc6'*v6;
